/* ksnet.h
------------------------------------------------------------------------
    Ksnet : ƻֽ淿 kinematic wave ǥ
------------------------------------------------------------------------
*/

#if !defined(_ksnet_h)
#define _ksnet_h

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "common.h"                                 /* ̴Ķ */
#include "list.h"                               /* 饹 List  */
#include "element.h"                         /* 饹 Element  */
#include "p_tmp.h"         /* ƥץ졼ȥ饹 Receive, Send  */


class Ksnet : public Element {

/* ü */
  protected:
	Receive<double>* rpu;
	Receive<double>* rpl;
  protected:
	void Register_receive_ports(void);

/* ü */
  protected:
	Send<double> sp;
	void Register_send_ports(void);

/* ѥ᥿ */
  protected:
	int ninput;                 /* ήβƻ֤ήƻʬ */
	int nlateral;                                     /* ¦ήο */
	int nsegment;				                      /* ƻʬο */
	// ϥ󥹥ȥ饯ΰȤͿ

	double* L;					                            /* Ĺ */
	double* B;                                              /* ƻ */
	double* K;                                      /* kinematic  */
	double* P;                                      /* kinematic  */
	double sum_length;                          /* ƲƻʬĹι */
	double area;                                  /* ƻ */
	
	int* sigma;                                 /* ήƻʬ */
	int** myu;                                /* ήƻʬ³ */

/*  */
	double* input_next_time;    /* 줫׻Ǥξήüή */
	double* input_current_time;        /* current_time Ǥξήüή */

	double sum_input_next;                  /* input_next_time  */
	double sum_input_current;            /* input_current_time  */

	double lateral_next_time;     /* 줫׻Ǥ¦ή */
	double lateral_current_time;         /* current_time Ǥ¦ή */

	double q0;                                          /* ήѲΨ */
	
	double* Q_down;                    /* ƲƻʬκǲήǤή̤
									         ǼؤΥݥ */
	
	double storage_current_time;                            /* α */
	double output_next_time, output_current_time;           /* ή */

/* ؿ󥹥ȥ饯ǥȥ饯 */
  public:
 	Boolean Init(char* o_name, int o_num, char* p_str,
		int numinput, int numlateral, int numsegment);

	Ksnet(char* o_name, int o_num, char* p_str,
		int numinput, int numlateral, int numsegment);
	// class_name  "Ksnet" ꤷobject_name 
	// o_name ˡϿ numinput ˡ¦ή
	// numlateral ˡƻʬ	numsegment ꤹ롣

	Ksnet(void);

	~Ksnet(void);
	// LBKPinput_next_timeinput_current_time
	// Q_downrpurpl õ롣

/* ѥ᥿ꡦ̤ν */
  public:
	void Set_parameter(FILE* fp);
	// kinematic  KP ȶĹ L ƻ B 
	//  ninput ĤǤ
	// (input_next_time, input_current_time) 
	// (ninput + nsegment)ĤǤ Q_down 
	// Ѱդ롣
			
	// ѥ᥿ѥեν
	// 
	// ֹμ㤤ƻʬ鵭
	// ͿڤӤν񼰤ϼ̤ꡣ
	//  
	// L B grad manning P
	//     L -> ƻʬĹ
	//     B -> ƻʬ
	//     P -> kinematic 
	//          A(̿) = K * pow(Q(ή), P)
	//     K = pow(B, 1 - P)
	//               * pow((sqrt(grad) / manning), - P)
	//
	// ()
	// 240.6 30.1 0.002 0.3 0.6
	// 190.2 23.6 0.001 0.3 0.6
	// ...

	void Set_initial_state(FILE* fp);

	// ѥեν
	//  : ׻ϻ

	void Save_terminal_state(FILE* fp);
	// ׻λե˽Ϥ

  protected:
	void Sub_connect(char* cf_name);
		/*
		 Ksnet::Sub_connect  ήƻʬ
			ե̾ cf_name Υե뤫ήƻʬ
			ؤ³ꤹ롣

			Sub_connect Ϳեν
			狼Ť餤Τǡ򤢤
			) 1    2
			     \  /
				4 \/ 5   3        οϲƻʬֹǡ
				   \    /         ή¦㤤ֹ椬դƤ롣
				  7 \  / 6        1, 2, 3 ˤбƻʬʤ
					 \/           ǾήüɽȤˤ롣
					  \
					 8 \

			---<from here>---
			# file for infomation of sub_connect
			# ֹμ㤤ƻʬ鵭롣ǸС
			# 1, 2, 3 ˤбƻʬʤΤФ
			# 4, 5, 6, 7, 8 ФƾͿ롣
			# ͿڤӤν񼰤ϼ̤ꡣ
			# 
			# num : a b c ...
			#     num       -> βƻʬήƻʬο
			#     a,b,c,... -> ήƻʬֹ(num ¤٤)
			#
			# Ƭ '#' ΤԤԤ̵뤵

			1 : 1
			1 : 2
			1 : 3
			2 : 4 5
			2 : 6 7
			...
			---<to here>---
		*/

  protected:
	double Storage_by_continuity(double q0_tmp);
	// Ϣ³ǺʬŸα̤׻

	void Get_input_info(void);
	// ήüǤή

	double Storage_by_integral(double q0_tmp);
	// Ʋƻ̤̿ѤʬƲƻα̤
	// ׻

  public:
	Boolean Initial_output(void);
	time_t Calculate_time_step(void);
	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
//	Boolean Can_you_calculate(void) { return YES; }
 	Boolean Calculate(void);
	Boolean Work(void) { return Work0(); }

};

#endif
