#include <stdio.h>
#include <time.h>

#include "total.h"				// 饹 Total_system 
#include "p_tmp.h"
#include "ksnet.h"

class TestKsnet : public Total_system {

/* ü */
  protected:
	I_file<double> inp_up;
	I_file<double> inp_lateral;
	void Register_input_ports(void)
	{
		Register((void*) &(inp_up));
		Register((void*) &(inp_lateral));
	}
	
/* ü */
  protected:
	O_file<double> outp;
	void Register_output_ports(void)
	{
		Register((void*) &outp);
	}
		
/* ֥ */
  protected:
	Ksnet net;
	void Register_components(void)
	{
		Register((void*) &net);
	}

	void Register_iterators(void) {}

/* ³ */
  protected:
	void Connect_ports(void)
	{
		Connect(((void*) &inp_up), ((void*) &net),
				"Receive", "rpu", 0);	
		Connect(((void*) &inp_up), ((void*) &net),
				"Receive", "rpu", 1);
		Connect(((void*) &inp_lateral), ((void*) &net),
				"Receive", "rpl", 0);
		Connect(((void*) &net), "Send", "sp", 0,
				((void*) &outp));
	}
	
	void Connect_components(void) {}

/* 󥹥ȥ饯 */
  public:
	TestKsnet(void)
		:	Total_system(),
			inp_up("tksnet.iu"),
			inp_lateral("tksnet.il"),
			outp("tksnet.out"),
			net("net", 0, "tksnet.cnt", 2, 1, 3)
	{
		class_name = "TestKsnet";
		Init("total_system", 0, 0);
	}
};



/* ᥤץ */

int main(void)
{
	TestKsnet total_system;		// ηϥǥ

	if (total_system.Construct() != YES)
		{ printf("\n# Failure : Construct.\n"); return 1; }

	if (total_system.Switch() != YES)
		{ printf("\n# Failure : Switch.\n"); return 1; }
	
	if (total_system.Are_you_ready() != YES)
		{ printf("\n# Failure : Are_you_ready.\n"); return 1; }
	
	// ѥ᥿ե뤫ɤߤȤ
	total_system.Read_parameter_file("tksnet.pmt");

	// ֤ե뤫ɤߤȤ
	total_system.Read_initial_state_file("tksnet.ist");

	// üҥǡꥹȥ
	total_system.Read_send_port_file("tksnet.isd");
	
	total_system.Initial_work();
	total_system.Work();
	
	// ǽ֤ե¸
	total_system.Write_terminal_state("tksnet.tst");

	// üҤ˻ĤäƤǡե¸
	total_system.Write_send_port_stock("tksnet.tsd");
	return 0;
}
